/* In effetto[] sono contenuti i puntatori a tutti gli effetti sonori;
 * questa funziona suona quello richiesto (se il sonoro è abilitato nelle opzioni) */
void suona(short n)
{
  if (opzione.sonoro)
  {
    Mix_PlayChannel(-1, effetto[n], 0);
  }
}

/* Restituisce true se il livello è completato (non ci sono blocchi sullo schermo) */
bool completato()
{
  for (short x = 0; x < width; x++)
    for (short y = 0; y < height; y++)
      { if (block[x][y] >  9 && block[x][y] < 128) return false; }
  return true;
}

class proietto {
  private:
    double x, y;
    double xv, yv;
    angolo direzione;
    double speed;
    bool trapassa;
    Uint32 colore;
    bool urto(unsigned int xa, unsigned int ya)
    {
      xa = xa / largBlock; ya = ya / altBlock;
      if (block[xa][ya] > 9) /* Se qui c'è un pezzo... - vedere anche leggimi.txt */
      {
        short snd = 0;
        if (direzione.sin == 0 || direzione.cos == 0) return true; /* Non considera i casi limite */
        bool strong = false;
        switch (block[xa][ya])
        {
          case blocktype2: player.punti = player.punti + 10; block[xa][ya]--; break;
          case blocktype3: case blocktype4: player.punti = player.punti + 5 ; block[xa][ya]--; break;
          case blocktype5: player.punti = player.punti + 30; block[xa][ya] = 9; break;
          case blocktype6: speed = speed - 0.1; if (speed < 0.2) speed = 0.2; strong = true; break;
          case blocktype7: speed = speed + 0.1; if (speed > 0.5) speed = 0.5; strong = true; break;
          case blocktype8: player.lung = player.lung + 5; if (player.lung > 100) player.lung = 100; strong = true; break;
          case blocktype9: player.lung = player.lung - 5; if (player.lung < 10)  player.lung = 10; strong = true; break;
          case blocktype10: player.vite++; player.punti = player.punti - 50; block[xa][ya] = 9; strong = true; break;
          case blocktype11: player.punti = player.punti + 200; block[xa][ya] = 13; strong = true; break;
          case blocktype12: if (trapassa) block[xa][ya] = 9; snd = 2; break;
          case blocktype13: block[xa][ya] = 9; break;
          case blocktype14: case blocktype15: block[xa][ya]--; break;
          case blocktype16: trapassa = true; block[xa][ya] = 9; break;
          default: player.punti++; block[xa][ya] = 8; break;
        }
        suona(snd);
        if (completato()) return false; /* Controsenso, il controllo inverso è già usato */
        /* Fa rimbalzare la pallina */
        if (! trapassa || strong)
        {
          int xva = xv / largBlock, yva = yv / altBlock;
          if (xva == xa) direzione.sin = -direzione.sin;
            else if (yva == ya) direzione.cos = -direzione.cos;
              else
              {
                /* Caso eccezionale, il pezzo viene colpito preciso nell'angolo! */
                direzione.cos = -direzione.cos; direzione.sin = -direzione.sin;
                cout << "[I] Extraordinary case: you hit the block in its corner.\n";
              }
          /* e la rimette dov'era prima, onde evitare spiacevoli loop */
          x = xv; y = yv;
        }
      }
      return true;
    }
    bool scia()
    {
      for (short v = 0; v < 25; v++)
      { int aero = aCaso() * opzione.difficolta * 10;

        pixelRGBA(schermo, x +  aero * -direzione.cos + (aCaso() * 5 - 3), y + aero * direzione.sin + (aCaso() * 5 - 3), 0xF0 + (aCaso() * 30 - 16), 180 + (aCaso() * 40 - 20), 0, 0xFF);
        //pixelColor(schermo, x + (aCaso() * 10 - 6), y + (aCaso() * 10 - 6), colore);
      }
    }
  public:
    bool init() {
      x = 320; y = 450;
      /* Direzione casuale della pallina al primo rimbalzo, come consigliato da Luca Mtt*/
      double tmpAngle = ((double)(rand()) / (double)(RAND_MAX)) * M_PI;
      if (tmpAngle < M_PI / 4) tmpAngle = M_PI / 4;
        else if (tmpAngle > M_PI * 3 / 4) tmpAngle = M_PI * 3 / 4;
      direzione.cos = cos(tmpAngle);
      direzione.sin = sin(tmpAngle);
      speed = 0.3;
      if (player.difficolta == 1) speed = speed / 2; else if (player.difficolta == 3) speed = speed * 2;
      trapassa = false;
      return true; }
    char muovi() {
      xv = x; yv = y;
      x = x + speed * direzione.cos;
      y = y - speed * direzione.sin;
      if (! urto(x, y)) return 'c'; /* Livello completato */
      /* Rimbalzo su bordo o paddle */
      if (x >= 639 || x <= 0) direzione.cos = -direzione.cos;
      if (y <= 0) direzione.sin = -direzione.sin;
      if (y >= 460)
      {
        if (x > (player.x - player.lung) && x < (player.x + player.lung))
        {
          /* Calcolo del nuovo coseno dell'angolo in funzione del punto del paddle
             col quale il giocatore urta la palla */
          double corner = (x - (player.x - player.lung)) * M_PI / (player.lung * 2);
          if (corner < M_PI / 12) corner = M_PI / 12;
            else if (corner > M_PI * 11 / 12) corner = M_PI * 11 / 12;
          direzione.cos = -cos(corner);
          if (direzione.sin < 0) player.punti--;
          direzione.sin = sin(corner);
          return 'h';
        }
        else if (y >= 465) return 'l'; /* Pallina persa */
      }
      return 'o';
    }
    bool grafica()
    {
      if (trapassa) colore = 0xFF0000FF;
        else colore = 0xC8C8C8FF;
      filledCircleColor(schermo, x, y, 5, colore);
      if (trapassa) scia();
    }
};



