/* Inizializza una nuova partita */
bool init()
{
  cout << "[I] Init() the game...";
  player.punti = 0;
  player.parziale = 0;
  player.vite = 2;
  player.difficolta = opzione.difficolta;
  lvl = opzione.startLvl;
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  if (! filelvl.is_open()) filelvl.open("livelli.lvl", ios::in | ios::out | ios::binary);
  cout << "[DONE]\n";
  return true;
}

/* Inizializza un nuovo set */
bool begin()
{
  player.x = 320;
  player.lung = 40; /* Metà paddle */
  if (! palla.init()) return false;
  Mix_Volume(-1, opzione.volumeEffetti);
  msg("Premi Spazio per iniziare");
  return true;
}

/* Disegna tutti gli elementi grafici dello schermo */
bool grafica()
{
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF); /* Cancella tutto */
  Uint32 colore;
  for (short y = 0; y < height; y++)
    for (short x = 0; x < width; x++)
    {
      /* per maggiori informazioni vedere leggimi.txt nelle Note per i Programmatori */
      switch (block[x][y])
      {
        case blocktype0: case blocktype1: colore = 0x000000FF; break;  /* vuoto */
        case blocktype2: colore = 0x008200FF; break;
        case blocktype3: colore = 0xB40000FF; break;
        case blocktype4: colore = 0x0000B4FF; break;
        case blocktype5: colore = 0xFDD017FF; break;
        case blocktype6: colore = 0x800080FF; break;
        case blocktype7: colore = 0xFF00FFFF; break;
        case blocktype8: colore = 0xFFA500FF; break;
        case blocktype9: colore = 0xFFFF00FF; break;
        case blocktype10: colore = 0xFFFFFFFF; break;
        case blocktype11: colore = 0x00000000; break;
        case blocktype12: colore = 0x404040FF; break;
        case blocktype13: colore = 0x606060FF; break;
        case blocktype14: colore = 0x505050FF; break;
        case blocktype15: colore = 0x404040FF; break;
        case blocktype16: colore = 0x00D2D2FF; break;
        default: colore = 0x400000CC; scrivi("Bad block found!\n"); clog << "[W] Bad block found!\n"; break;
      }
      boxColor(schermo, x * largBlock, y * altBlock, x * largBlock + largBlock - 2, y * altBlock + altBlock - 2, colore);
    }

  roundedBoxColor(schermo, player.x - player.lung, 460, player.x + player.lung, 470, 1, 0xC8C8C8FF);
  palla.grafica();
  stringColor(schermo, 10, 5, "Vite:", 0xFFFFFFFF);
  stringColor(schermo, 58, 5, itoa(player.vite), 0xFFFFFFFF);
  stringColor(schermo, 140, 5, "Punti:", 0xFFFFFFFF);
  stringColor(schermo, 196, 5, itoa(player.punti), 0xFFFFFFFF);
  stringColor(schermo, 300, 5, itoa(lvl), 0xFFFFFFFF);
  stringColor(schermo, 320, 5, title, 0xC80000FF);
  SDL_Flip(schermo);
  return true;
}

/* Ritorna true solo se è passato almeno il tempo di un fotogramma, così, se
 * l'esecuzione è stata molto veloce, evita di ridisegnare inutilmente lo schermo
 * Nel frattempo inserisce un leggero SDL_Delay() per evitare di fondere la CPU
 * Il gioco potrebbe venire rallentato se il processore è troppo lento, ma si
 * evita almeno che diventi ingiocabile su processori troppo veloci */
bool fps()
{
  /* periodo = 1/maxfps (indicare in millisecondi) */
  int periodo = 40; /* Consigliato: 33 (~ 30 fps) oppure 40 (~ 25 fps) */
  unsigned int ritardo = SDL_GetTicks() - lastframe + 1;
  if (ritardo < periodo) { SDL_Delay(1); return false; }
  lastframe = SDL_GetTicks();
  return true;
}

bool gioca(bool nuovo) {
  if (nuovo)
  {
    if (! init()) { cerr << "[E] Fatal error: unable to init() the game!\n"; return false; }
    if (! begin()) { cerr << "[E] Fatal error: unable to begin() the game!\n"; return false; }
    if (! livello()) return false;
  }
  else
  {
    if (! filelvl.is_open()) filelvl.open("livelli.lvl", ios::in | ios::out | ios::binary);
    if (! carica()) { cerr << "[E] Fatal error: unable to carica() the saved match!\n"; return false; }
    grafica();
    if (! begin()) { cerr << "[E] Fatal error: unable to begin() the game!\n"; return false; }
  }

  while (true)
  {
    SDL_PumpEvents();
    if (tasto[SDLK_RIGHT]) player.x = player.x + 0.2 * player.difficolta;
    if (tasto[SDLK_LEFT]) player.x = player.x - 0.2 * player.difficolta;
    if (tasto[SDLK_ESCAPE]) { gameover(); return true; }
    if (tasto[SDLK_s]) { if (salva()) return true; }
    if (tasto[SDLK_a])
    {
      scrivi("\a\n"); scrivi("Abbandono del livello");
      player.vite--;
      if (player.vite < 0) { gameover(); return true; }
        else { begin(); livello(); }
    }
    if (tasto[SDLK_p]) { msg(" -- Pausa -- ");}

    /* Evita che il paddle esca dallo schermo */
    if (player.x <= 0) player.x = 0;
    if (player.x >= 639) player.x = 639;
    switch (palla.muovi())
    {
      case 'l': /* Palla persa */
        player.vite--;
        if (player.vite < 0) { gameover(); record(); return true; }
          else begin();
        break;
      case 'c': /* Livello completato */
        livello();
        if (opzione.autosave) salva(true); /* Salvataggio automatico */
        begin();
        break;
      case 'o': /* Ok */ break;
      case 'h':
        suona(1);
        if (player.punti - player.parziale >= 5000)
        {
          player.vite++; player.parziale = player.punti;
          msg("Hai appena guadagnato una vita extra!");
        }
        break;
      default: clog << "[W] Unespected return value from muovi() in class 'proietto'" << endl; break;
    }

    if (fps()) grafica();
    if (opzione.sonoro && ! Mix_PlayingMusic()) Mix_PlayMusic(musica, 0);
  }

  return true;
}

